// generated from rosidl_typesupport_fastrtps_cpp/resource/idl__type_support.cpp.em
// with input from mrpt_msgs:msg/NetworkOfPoses.idl
// generated code does not contain a copyright notice
#include "mrpt_msgs/msg/detail/network_of_poses__rosidl_typesupport_fastrtps_cpp.hpp"
#include "mrpt_msgs/msg/detail/network_of_poses__struct.hpp"

#include <limits>
#include <stdexcept>
#include <string>
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_fastrtps_cpp/identifier.hpp"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support.h"
#include "rosidl_typesupport_fastrtps_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_fastrtps_cpp/wstring_conversion.hpp"
#include "fastcdr/Cdr.h"


// forward declaration of message dependencies and their conversion functions
namespace mrpt_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const mrpt_msgs::msg::NodeIDWithPoseVec &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  mrpt_msgs::msg::NodeIDWithPoseVec &);
size_t get_serialized_size(
  const mrpt_msgs::msg::NodeIDWithPoseVec &,
  size_t current_alignment);
size_t
max_serialized_size_NodeIDWithPoseVec(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace mrpt_msgs

namespace mrpt_msgs
{
namespace msg
{
namespace typesupport_fastrtps_cpp
{
bool cdr_serialize(
  const mrpt_msgs::msg::GraphConstraint &,
  eprosima::fastcdr::Cdr &);
bool cdr_deserialize(
  eprosima::fastcdr::Cdr &,
  mrpt_msgs::msg::GraphConstraint &);
size_t get_serialized_size(
  const mrpt_msgs::msg::GraphConstraint &,
  size_t current_alignment);
size_t
max_serialized_size_GraphConstraint(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment);
}  // namespace typesupport_fastrtps_cpp
}  // namespace msg
}  // namespace mrpt_msgs


namespace mrpt_msgs
{

namespace msg
{

namespace typesupport_fastrtps_cpp
{

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_mrpt_msgs
cdr_serialize(
  const mrpt_msgs::msg::NetworkOfPoses & ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  // Member: root
  cdr << ros_message.root;
  // Member: nodes
  mrpt_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
    ros_message.nodes,
    cdr);
  // Member: constraints
  {
    size_t size = ros_message.constraints.size();
    cdr << static_cast<uint32_t>(size);
    for (size_t i = 0; i < size; i++) {
      mrpt_msgs::msg::typesupport_fastrtps_cpp::cdr_serialize(
        ros_message.constraints[i],
        cdr);
    }
  }
  return true;
}

bool
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_mrpt_msgs
cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  mrpt_msgs::msg::NetworkOfPoses & ros_message)
{
  // Member: root
  cdr >> ros_message.root;

  // Member: nodes
  mrpt_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
    cdr, ros_message.nodes);

  // Member: constraints
  {
    uint32_t cdrSize;
    cdr >> cdrSize;
    size_t size = static_cast<size_t>(cdrSize);
    ros_message.constraints.resize(size);
    for (size_t i = 0; i < size; i++) {
      mrpt_msgs::msg::typesupport_fastrtps_cpp::cdr_deserialize(
        cdr, ros_message.constraints[i]);
    }
  }

  return true;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_mrpt_msgs
get_serialized_size(
  const mrpt_msgs::msg::NetworkOfPoses & ros_message,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  // Member: root
  {
    size_t item_size = sizeof(ros_message.root);
    current_alignment += item_size +
      eprosima::fastcdr::Cdr::alignment(current_alignment, item_size);
  }
  // Member: nodes

  current_alignment +=
    mrpt_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
    ros_message.nodes, current_alignment);
  // Member: constraints
  {
    size_t array_size = ros_message.constraints.size();

    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);

    for (size_t index = 0; index < array_size; ++index) {
      current_alignment +=
        mrpt_msgs::msg::typesupport_fastrtps_cpp::get_serialized_size(
        ros_message.constraints[index], current_alignment);
    }
  }

  return current_alignment - initial_alignment;
}

size_t
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_PUBLIC_mrpt_msgs
max_serialized_size_NetworkOfPoses(
  bool & full_bounded,
  bool & is_plain,
  size_t current_alignment)
{
  size_t initial_alignment = current_alignment;

  const size_t padding = 4;
  const size_t wchar_size = 4;
  (void)padding;
  (void)wchar_size;

  full_bounded = true;
  is_plain = true;


  // Member: root
  {
    size_t array_size = 1;

    current_alignment += array_size * sizeof(uint64_t) +
      eprosima::fastcdr::Cdr::alignment(current_alignment, sizeof(uint64_t));
  }

  // Member: nodes
  {
    size_t array_size = 1;


    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      current_alignment +=
        mrpt_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_NodeIDWithPoseVec(
        inner_full_bounded, inner_is_plain, current_alignment);
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  // Member: constraints
  {
    size_t array_size = 0;
    full_bounded = false;
    is_plain = false;
    current_alignment += padding +
      eprosima::fastcdr::Cdr::alignment(current_alignment, padding);


    for (size_t index = 0; index < array_size; ++index) {
      bool inner_full_bounded;
      bool inner_is_plain;
      current_alignment +=
        mrpt_msgs::msg::typesupport_fastrtps_cpp::max_serialized_size_GraphConstraint(
        inner_full_bounded, inner_is_plain, current_alignment);
      full_bounded &= inner_full_bounded;
      is_plain &= inner_is_plain;
    }
  }

  return current_alignment - initial_alignment;
}

static bool _NetworkOfPoses__cdr_serialize(
  const void * untyped_ros_message,
  eprosima::fastcdr::Cdr & cdr)
{
  auto typed_message =
    static_cast<const mrpt_msgs::msg::NetworkOfPoses *>(
    untyped_ros_message);
  return cdr_serialize(*typed_message, cdr);
}

static bool _NetworkOfPoses__cdr_deserialize(
  eprosima::fastcdr::Cdr & cdr,
  void * untyped_ros_message)
{
  auto typed_message =
    static_cast<mrpt_msgs::msg::NetworkOfPoses *>(
    untyped_ros_message);
  return cdr_deserialize(cdr, *typed_message);
}

static uint32_t _NetworkOfPoses__get_serialized_size(
  const void * untyped_ros_message)
{
  auto typed_message =
    static_cast<const mrpt_msgs::msg::NetworkOfPoses *>(
    untyped_ros_message);
  return static_cast<uint32_t>(get_serialized_size(*typed_message, 0));
}

static size_t _NetworkOfPoses__max_serialized_size(char & bounds_info)
{
  bool full_bounded;
  bool is_plain;
  size_t ret_val;

  ret_val = max_serialized_size_NetworkOfPoses(full_bounded, is_plain, 0);

  bounds_info =
    is_plain ? ROSIDL_TYPESUPPORT_FASTRTPS_PLAIN_TYPE :
    full_bounded ? ROSIDL_TYPESUPPORT_FASTRTPS_BOUNDED_TYPE : ROSIDL_TYPESUPPORT_FASTRTPS_UNBOUNDED_TYPE;
  return ret_val;
}

static message_type_support_callbacks_t _NetworkOfPoses__callbacks = {
  "mrpt_msgs::msg",
  "NetworkOfPoses",
  _NetworkOfPoses__cdr_serialize,
  _NetworkOfPoses__cdr_deserialize,
  _NetworkOfPoses__get_serialized_size,
  _NetworkOfPoses__max_serialized_size
};

static rosidl_message_type_support_t _NetworkOfPoses__handle = {
  rosidl_typesupport_fastrtps_cpp::typesupport_identifier,
  &_NetworkOfPoses__callbacks,
  get_message_typesupport_handle_function,
};

}  // namespace typesupport_fastrtps_cpp

}  // namespace msg

}  // namespace mrpt_msgs

namespace rosidl_typesupport_fastrtps_cpp
{

template<>
ROSIDL_TYPESUPPORT_FASTRTPS_CPP_EXPORT_mrpt_msgs
const rosidl_message_type_support_t *
get_message_type_support_handle<mrpt_msgs::msg::NetworkOfPoses>()
{
  return &mrpt_msgs::msg::typesupport_fastrtps_cpp::_NetworkOfPoses__handle;
}

}  // namespace rosidl_typesupport_fastrtps_cpp

#ifdef __cplusplus
extern "C"
{
#endif

const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_fastrtps_cpp, mrpt_msgs, msg, NetworkOfPoses)() {
  return &mrpt_msgs::msg::typesupport_fastrtps_cpp::_NetworkOfPoses__handle;
}

#ifdef __cplusplus
}
#endif
